#ifndef __FIELD__
#define __FIELD__

using XMLIOSERVER::XML::XMLNode;
using XMLIOSERVER::XML::THashAttributes;

namespace XMLIOSERVER
{
   class CGrid; // CGRID = CDOMAINE + CAXIS

   class CField : public ObjectTemplate<CField>, public FieldAttribut
   {
      public:

         CField(void) : ObjectTemplate<CField>(), FieldAttribut(), grid(NULL)
         {/* Ne rien faire de plus */}
         CField(const string& _id) : ObjectTemplate<CField>(_id), FieldAttribut(), grid(NULL), foper(NULL)
         {/* Ne rien faire de plus */}

         static string GetName(void) { return ("field"); }

         inline void SolveGridRef(void) ;

         const CGrid* getGrid(void) const { return (grid); }
         const Array<double, 1>& getData(void) const { return (data); }
         const FieldOperation* getFieldOperation(void) const { return (foper); }

         virtual CField* getReference(void) const
         {
            if(!field_ref.hasValue()) return (NULL);
            if (!CField::HasObject(field_ref))
            { WARNING("Référence invalide sur l'objet "+GetName()+" nommé \""+((string)field_ref)+"\""); return (NULL); }

            return (CField::GetObject(field_ref));
         }

         virtual ~CField(void)
         { /* Ne rien faire de plus */ }

      private :

         CGrid* grid ;
         FieldOperation* foper;
         Array<double, 1> data;

   }; // class CField

} // namespace XMLIOSERVER

DECLARE_GROUP(Field)

#endif // __FIELD__
